SystemOrganization addCategory: #'Seaside-Tests-Slime'!

WAObject subclass: #WASlimeMockWAObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!WASlimeMockWAObject methodsFor: 'initialization' stamp: 'lr 11/14/2008 23:57'!
initialize! !

!WASlimeMockWAObject methodsFor: 'copying' stamp: 'lr 11/14/2008 23:57'!
postCopy! !

!WAPackage class methodsFor: '*seaside-tests-slime' stamp: 'jf 1/11/2009 14:12'!
seasideTestsSlime
	^ self new
		name: 'Seaside-Tests-Slime';
		description: 'Unit tests for the package Seaside-Slime.';
		addDependency: 'Seaside-Slime';
		addDependency: 'Seaside-Tests-Component';
		yourself! !

Object subclass: #WASlimeMockObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!WASlimeMockObject methodsFor: 'accessing' stamp: 'lr 7/15/2008 23:44'!
callbackTemps
	| r |
	r := OrderedCollection new.
	(1 to: 10) do: [ :e | r add: [ e ] ]! !

!WASlimeMockObject methodsFor: 'initialization' stamp: 'lr 11/14/2008 23:59'!
initialize
	super initialize! !

!WASlimeMockObject methodsFor: 'accessing' stamp: 'lr 7/15/2008 23:13'!
someClass
	Semaphore new! !

!WASlimeMockObject methodsFor: 'accessing' stamp: 'lr 7/15/2008 23:26'!
someMessage
	^ true and: [ false ] and: [ nil ]! !

WASession subclass: #WASlimeMockSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!WASlimeMockSession methodsFor: 'as yet unclassified' stamp: 'pmm 10/18/2008 20:27'!
expired! !

WAComponent subclass: #WASlimeMockComponent
	instanceVariableNames: 'foo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:21'!
renderAvoidUnnecessaryWithOn: html
	html div with: 'foo'! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:36'!
renderChangesStateWhileRenderingOn: html
	html div: [ foo := nil ]! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:24'!
renderContentOn: html
	super renderContentOn: html! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 22:17'!
renderDoNotUseWhileRenderingOn: html
	html div: [ self call: foo ]! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 22:17'!
renderDoNotUseWithinCallbackOn: html
	html anchor
		callback: [ self session addLoadScript: nil ];
		with: 'foo'! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:22'!
renderExtractCallbackCodeToMethodOn: html
	html anchor callback: [ self foo. self bar ]; with: 'foo'! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'jf 1/11/2009 14:11'!
renderInstantiatesComponentWhileRenderingOn: html
	html div: WAComponentMock new! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:38'!
renderSendsDeprecatedMessageOn: html
	html anchor src: 'http://www.foo.com'; with: 'Foo'! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:35'!
renderUnnecessaryBlockPassedToBrushOn: html
	html div: [ html render: 'foo' ]! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:08'!
renderUsesWrongRendererOn: html
	html updater callback: [ :r | html div ]! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 22:27'!
renderWithHasToBeLastMessageInCascadeOn: html
	html div
		with: 'foo';
		class: 'bar'! !

!WASlimeMockComponent methodsFor: 'actions' stamp: 'lr 7/15/2008 23:26'!
sendsRenderContentOn
	self renderContentOn: nil! !

TestCase subclass: #WASlimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!WASlimeTest methodsFor: 'actions' stamp: 'lr 1/11/2009 22:31'!
run: aRule selectors: aSelectorCollection 
	self 
		run: aRule
		selectors: aSelectorCollection
		in: (Array 
			with: WASlimeMockComponent
			with: WASlimeMockObject
			with: WASlimeMockSession
			with: WASlimeMockWAObject)! !

!WASlimeTest methodsFor: 'actions' stamp: 'lr 7/15/2008 23:41'!
run: aRule selectors: aSelectorCollection in: aClassCollection 
	| searchEnvironment resultEnvironment |
	searchEnvironment := ClassEnvironment 
		onEnvironment: BrowserEnvironment new
		classes: aClassCollection.
	SmalllintChecker
		runRule: aRule
		onEnvironment: searchEnvironment.
	resultEnvironment := aRule result.
	self assert: resultEnvironment problemCount = aSelectorCollection size.
	aSelectorCollection do: [ :selector |
		self assert: (resultEnvironment classes
			anySatisfy: [ :class | resultEnvironment includesSelector: selector in: class ]) ]! !

!WASlimeTest methodsFor: 'testing-misc' stamp: 'lr 1/11/2009 22:10'!
testAvoidUnnecessaryWith
	self 
		run: WASlimeParseTreeLintRule avoidUnnecessaryWith
		selectors: #(#renderAvoidUnnecessaryWithOn: )! !

!WASlimeTest methodsFor: 'testing-misc' stamp: 'lr 1/11/2009 22:10'!
testBasicNewInitializeMissing
	self 
		run: WASlimeBlockLintRule basicNewInitializeMissing
		selectors: #(#initialize )! !

!WASlimeTest methodsFor: 'testing-possible' stamp: 'lr 1/11/2009 22:10'!
testChangesStateWhileRendering
	self 
		run: WASlimeBlockLintRule changesStateWhileRendering
		selectors: #(#renderChangesStateWhileRenderingOn: )! !

!WASlimeTest methodsFor: 'testing-bugs' stamp: 'lr 1/11/2009 22:10'!
testDoNotUseWhileRendering
	self 
		run: WASlimeBlockLintRule doNotUseWhileRendering
		selectors: #(#renderDoNotUseWhileRenderingOn: )! !

!WASlimeTest methodsFor: 'testing-bugs' stamp: 'lr 1/11/2009 22:10'!
testDoNotUseWithinCallback
	self 
		run: WASlimeBlockLintRule doNotUseWithinCallback
		selectors: #(#renderDoNotUseWithinCallbackOn: )! !

!WASlimeTest methodsFor: 'testing-misc' stamp: 'lr 1/11/2009 22:10'!
testDontCallSuperInitialize
	self 
		run: WASlimeBlockLintRule invalidObjectInitialization
		selectors: #(#initialize )! !

!WASlimeTest methodsFor: 'testing-misc' stamp: 'lr 1/11/2009 22:10'!
testExtractCallbackCodeToMethod
	self 
		run: WASlimeParseTreeLintRule extractCallbackCodeToMethod
		selectors: #(#renderExtractCallbackCodeToMethodOn: )! !

!WASlimeTest methodsFor: 'testing-possible' stamp: 'lr 1/11/2009 22:10'!
testFixCallbackTempsMissing
	self 
		run: WASlimeParseTreeLintRule fixCallbackTempsMissing
		selectors: #(#callbackTemps )! !

!WASlimeTest methodsFor: 'testing-bugs' stamp: 'lr 1/11/2009 22:10'!
testImplementsSessionExpired
	self 
		run: WASlimeBlockLintRule implementsSessionExpired
		selectors: #(#expired )! !

!WASlimeTest methodsFor: 'testing-bugs' stamp: 'lr 1/11/2009 22:10'!
testInstantiatesComponentWhileRendering
	self 
		run: WASlimeBlockLintRule instantiatesComponentWhileRendering
		selectors: #(#renderInstantiatesComponentWhileRenderingOn: )! !

!WASlimeTest methodsFor: 'testing-misc' stamp: 'lr 1/11/2009 22:10'!
testSendsNotPortableMessage
	self 
		run: WASlimeParseTreeLintRule sendsNotPortableMessage
		selectors: #(#someMessage )! !

!WASlimeTest methodsFor: 'testing-misc' stamp: 'lr 1/11/2009 22:10'!
testSendsRenderContentOn
	self 
		run: WASlimeParseTreeLintRule sendsRenderContentOn
		selectors: #(#sendsRenderContentOn )! !

!WASlimeTest methodsFor: 'testing-misc' stamp: 'lr 1/11/2009 22:10'!
testUnnecessaryBlockPassedToBrush
	self 
		run: WASlimeParseTreeLintRule unnecessaryBlockPassedToBrush
		selectors: #(#renderUnnecessaryBlockPassedToBrushOn: )! !

!WASlimeTest methodsFor: 'testing-misc' stamp: 'lr 1/11/2009 22:10'!
testUsesCurlyBraceArrays
	self 
		run: WASlimeBlockLintRule usesCurlyBraceArrays
		selectors: #()! !

!WASlimeTest methodsFor: 'testing-misc' stamp: 'lr 1/11/2009 22:10'!
testUsesLiteralByteArrays
	self 
		run: WASlimeBlockLintRule usesLiteralByteArrays
		selectors: #()! !

!WASlimeTest methodsFor: 'testing-misc' stamp: 'lr 1/11/2009 22:10'!
testUsesNotPortableClass
	self 
		run: WASlimeBlockLintRule usesNotPortableClass
		selectors: #(#someClass )! !

!WASlimeTest methodsFor: 'testing-bugs' stamp: 'lr 1/11/2009 22:10'!
testUsesWrongRenderer
	self 
		run: WASlimeParseTreeLintRule usesWrongRenderer
		selectors: #(#renderUsesWrongRendererOn: )! !

!WASlimeTest methodsFor: 'testing-bugs' stamp: 'lr 1/11/2009 22:10'!
testWithHasToBeLastMessageInCascade
	self 
		run: WASlimeParseTreeLintRule withHasToBeLastMessageInCascade
		selectors: #(#renderWithHasToBeLastMessageInCascadeOn: )! !
